#
# hello.txrx.45.py

# detect rotation of disk based on
# step response transmit-receive hello-world
#    9600 baud FTDI interface
#
# Takuma Oami modify to the purpose
# fablab Vestmannaeyjar 4/8/14
#
# Neil Gershenfeld wrote original code
# CBA MIT 11/6/11
#
# (c) Massachusetts Institute of Technology 2011
# Permission granted for experimental and personal use;
# license for commercial sale available from MIT
#

from Tkinter import *
import serial

WINDOW = 600 # window size
eps = 0.75 # filter fraction
filt1 = 0.0 # filtered value(PB3)
filt2 = 0.0 # filtered value(PB4)

def idle(parent,canvas):
   global filt1, filt2, eps
   #
   # idle routine
   #
   byte2 = 0
   byte3 = 0
   byte4 = 0
   ser.flush()
   #
   # find framing 
   #
   while 1:
      byte1 = byte2
      byte2 = byte3
      byte3 = byte4
      byte4 = ord(ser.read())
      if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)):
         break
   #
   # read and plot
   #
   up_low1 = ord(ser.read())
   up_high1 = ord(ser.read())
   down_low1 = ord(ser.read())
   down_high1 = ord(ser.read())

   up_low2 = ord(ser.read())
   up_high2 = ord(ser.read())
   down_low2 = ord(ser.read())
   down_high2 = ord(ser.read())

   up_value1 = 256*up_high1 + up_low1
   down_value1 = 256*down_high1 + down_low1
   value1 = (up_value1 - down_value1)
   filt1 = (1-eps)*filt1 + eps*value1
   x1 = int(.2*WINDOW + (.9-.2)*WINDOW*filt1/10000.0)
   canvas.itemconfigure("text1",text="%.1f"%filt1)
   canvas.coords('rect11',.2*WINDOW,.05*WINDOW,x1,.2*WINDOW)
   canvas.coords('rect12',x1,.05*WINDOW,.9*WINDOW,.2*WINDOW)

   up_value2 = 256*up_high2 + up_low2
   down_value2 = 256*down_high2 + down_low2
   value2 = (up_value2 - down_value2)
   filt2 = (1-eps)*filt2 + eps*value2
   x2 = int(.2*WINDOW + (.9-.2)*WINDOW*filt2/10000.0)
   canvas.itemconfigure("text2",text="%.1f"%filt2)
   canvas.coords('rect21',.2*WINDOW,.25*WINDOW,x2,.4*WINDOW)
   canvas.coords('rect22',x2,.25*WINDOW,.9*WINDOW,.4*WINDOW)

   canvas.update()
   parent.after_idle(idle,parent,canvas)

#
#  check command line arguments
#
if (len(sys.argv) != 2):
   print "command line: hello.rotate.45.py serial_port"
   sys.exit()
port = sys.argv[1]
#
# open serial port
#
ser = serial.Serial(port,9600)
ser.setDTR()
#
# set up GUI
#
root = Tk()
root.title('hello.rotate.45.py (q to exit)')
root.bind('q','exit')
canvas = Canvas(root, width=WINDOW, height=.5*WINDOW, background='white')
#
canvas.create_text(.1*WINDOW,.125*WINDOW,text="1",font=("Helvetica", 24),tags="text1",fill="#0000b0")
canvas.create_rectangle(.2*WINDOW,.05*WINDOW,.3*WINDOW,.2*WINDOW, tags='rect11', fill='#b00000')
canvas.create_rectangle(.3*WINDOW,.05*WINDOW,.9*WINDOW,.2*WINDOW, tags='rect12', fill='#0000b0')

canvas.create_text(.1*WINDOW,.325*WINDOW,text="2",font=("Helvetica", 24),tags="text2",fill="#0000b0")
canvas.create_rectangle(.2*WINDOW,.25*WINDOW,.3*WINDOW,.4*WINDOW, tags='rect21', fill='#b00000')
canvas.create_rectangle(.3*WINDOW,.25*WINDOW,.9*WINDOW,.4*WINDOW, tags='rect22', fill='#0000b0')

canvas.pack()
#
# start idle loop
#
root.after(100,idle,root,canvas)
root.mainloop()
